//
//
//  Created by Zefir Kurtisi on 10.05.2006.
//

#include "pa_interface.h"



/*
 *************************************************
 * PortAudio Interface
 *************************************************
 */
 
// globaler Handler fuer Audiostream
PABLIO_Stream     *aStream;


// PortAudio im Modus blocking-IO und duplex oeffnen
int init_portaudio(void)
{
	 PaError err = OpenAudioStream( &aStream, SAMPLE_RATE, paInt16, (PABLIO_READ_WRITE | PABLIO_STEREO) );
	if(err!=paNoError)
	{
		printf("Fehler: Konnte PortAudio nicht oeffnen.");
		exit(0xaa);
	}
	return 0;
}

// PortAudio-Stream freigeben
void close_portaudio(void)
{
	CloseAudioStream( aStream );
}


// Abfrage Anzahl Samples, die geschrieben werden koennen
int get_pa_output_samples(void)
{
	return GetAudioStreamWriteable(aStream);
}

// Abfrage Anzahl Samples, die gelesen werden koennen
int get_pa_input_samples(void)
{
	return GetAudioStreamReadable(aStream);
}

/*
 * *NIX-konformes Lesen aus dem Audio-in-Buffer
 * - kopiert maximal <size> Bytes nach <buff>
 * - Rueckgabewert enthaehlt kopierte Bytes
 */
int read_audio(char *buff, int size)
{
	if(!buff)
		exit(0xdead);
	if(size<=0)
		return 0;
	int buffered=BYTES_PER_FRAME*GetAudioStreamReadable(aStream);
	if(size>buffered)
	{
		printf("audio-in hat statt %d Samples nur %d Bytes\n", size, buffered);
		size=buffered;
	}
	ReadAudioStream(aStream, buff, size);
	return size;
}

/*
 * Gegenstueck zum Schreiben von daten in Audio-out-Buffer
 */
int write_audio(char *buff, int size)
{
	if(!buff)
		exit(0xdead);
	if(size<=0)
		return 0;
	int buffer_space=BYTES_PER_FRAME*GetAudioStreamWriteable(aStream);
	if(size>buffer_space)
	{
		printf("audio-out kann statt %d Samples nur %d Bytes schreiben\n", size, buffer_space);
		size=buffer_space;
	}
	WriteAudioStream(aStream, buff, size);
	return size;
}


