
/*
 * Programmgeruest fuer die Aufgabe Voice Chat Tool VCT
 * Erstellt fuer das PKS im SS06
 * Zefir, kurtisi@ibr.cs.tu-bs.de
 *-----------------------------------------------
 */

#ifndef PA_INTERFACE_H
#define PA_INTERFACE_H

#include "portaudio/pablio.h"

/* Audio wird mit 48 kHz abgetastet / ausgegeben */
#define SAMPLE_RATE		(32000)
/* Samples werden mit 16 Bit aufgeloest */
#define BYTES_PER_SAMPLE	(2)
/* In Stereo */
#define CHANNELS		(2)

#define BYTES_PER_FRAME	(BYTES_PER_SAMPLE*CHANNELS)

// ===> jedes Sample hat 4 Bytes
// ===> pro Sekunde werden 128 kBytes Audiodaten erzeugt/verbraucht

/*
 * Funktionen fuer den Zugriff auf Audio
 */

int init_portaudio(void);	// PortAudio im Modus blocking-IO und duplex oeffnen
void close_portaudio(void);	// PortAudio-Stream freigeben
int get_pa_output_samples(void);  // Abfrage Anzahl Samples, die geschrieben werden koennen
int get_pa_input_samples(void); 	// Abfrage Anzahl Samples, die gelesen werden koennen
int read_audio(char *buff, int size);	// aus PortAudio-In-Buffer lesen
int write_audio(char *buff, int size);	// in PortAudio-Out-Buffer schreiben


#endif /* PA_INTERFACE_H */
